[Документация Yandex Cloud](../../../../index.md) > [Yandex Managed Service for Sharded PostgreSQL](../../../index.md) > Справочник API > [gRPC (англ.)](../index.md) > [Cluster](index.md) > ListLogs

# Managed Service for SPQR API, gRPC: ClusterService.ListLogs

Retrieves logs for the specified SPQR cluster.
See the [Logs](https://yandex.cloud/ru-kz/yandex-mdb-guide/concepts/logs.html) section in the developers guide for detailed logs description.

## gRPC request

**rpc ListLogs ([ListClusterLogsRequest](#yandex.cloud.mdb.spqr.v1.ListClusterLogsRequest)) returns ([ListClusterLogsResponse](#yandex.cloud.mdb.spqr.v1.ListClusterLogsResponse))**

## ListClusterLogsRequest {#yandex.cloud.mdb.spqr.v1.ListClusterLogsRequest}

```json
{
  "cluster_id": "string",
  "column_filter": [
    "string"
  ],
  "service_type": "ServiceType",
  "from_time": "google.protobuf.Timestamp",
  "to_time": "google.protobuf.Timestamp",
  "page_size": "int64",
  "page_token": "string",
  "always_next_page_token": "bool",
  "filter": "string",
  "order_by": "string"
}
```

#|
||Field | Description ||
|| cluster_id | **string**

Required field. ID of the SPQR cluster to request logs for.
To get the SPQR cluster ID use a [ClusterService.List](list.md#List) request.

The maximum string length in characters is 50. ||
|| column_filter[] | **string**

Columns from the logs table to request.
If no columns are specified, entire log records are returned. ||
|| service_type | enum **ServiceType**

Type of the service to request logs about.

- `POSTGRESQL`: Logs of SPQR activity.
- `ROUTER`
- `COORDINATOR`
- `INFRA` ||
|| from_time | **[google.protobuf.Timestamp](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#timestamp)**

Start timestamp for the logs request, in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. ||
|| to_time | **[google.protobuf.Timestamp](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#timestamp)**

End timestamp for the logs request, in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. ||
|| page_size | **int64**

The maximum number of results per page to return. If the number of available
results is larger than `page_size`, the service returns a [ListClusterLogsResponse.next_page_token](#yandex.cloud.mdb.spqr.v1.ListClusterLogsResponse)
that can be used to get the next page of results in subsequent list requests.
Acceptable values are 0 to 1000, inclusive. Default value: 100.

Acceptable values are 0 to 1000, inclusive. ||
|| page_token | **string**

Page token. To get the next page of results, set `page_token` to the
[ListClusterLogsResponse.next_page_token](#yandex.cloud.mdb.spqr.v1.ListClusterLogsResponse) returned by the previous list request.

The maximum string length in characters is 100. ||
|| always_next_page_token | **bool**

Always return `next_page_token`, even if current page is empty. ||
|| filter | **string**

A filter expression that filters resources listed in the response.
The expression must specify:
1. The field name. Currently filtering can be applied to the [LogRecord.logs.message.hostname], [LogRecord.logs.message.severity] fields.
2. A conditional operator. Can be either `=` or `!=` for single values, `IN` or `NOT IN` for lists of values.
3. The value. Must be 1-63 characters long and match the regular expression `^[a-z0-9.-]{1,61}$`.
Examples of a filter: `message.hostname='node1.db.cloud.yandex.net'`, `message.severity IN ('E', 'F')`

The maximum string length in characters is 1000. ||
|| order_by | **string** ||
|#

## ListClusterLogsResponse {#yandex.cloud.mdb.spqr.v1.ListClusterLogsResponse}

```json
{
  "logs": [
    {
      "timestamp": "google.protobuf.Timestamp",
      "message": "map<string, string>"
    }
  ],
  "next_page_token": "string"
}
```

#|
||Field | Description ||
|| logs[] | **[LogRecord](#yandex.cloud.mdb.spqr.v1.LogRecord)**

Requested log records. ||
|| next_page_token | **string**

This token allows you to get the next page of results for list requests. If the number of results
is larger than [ListClusterLogsRequest.page_size](#yandex.cloud.mdb.spqr.v1.ListClusterLogsRequest), use the `next_page_token` as the value
for the [ListClusterLogsRequest.page_token](#yandex.cloud.mdb.spqr.v1.ListClusterLogsRequest) query parameter in the next list request.
Each subsequent list request will have its own `next_page_token` to continue paging through the results.
This value is interchangeable with `next_record_token` from StreamLogs method. ||
|#

## LogRecord {#yandex.cloud.mdb.spqr.v1.LogRecord}

#|
||Field | Description ||
|| timestamp | **[google.protobuf.Timestamp](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#timestamp)**

Log record timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. ||
|| message | **object** (map<**string**, **string**>)

Contents of the log record. ||
|#